#include "SDL/SDL.h"
#include "math.h"
#include <iostream>
#include "fstream"
//#include "stdio.h"
//#include <stdlib.h>
#include <string.h>
#include "lodepng.cpp"

// SELECT 1 OR 2 TO COMPILE FOR OLD OR NEW SDL.
#define SDL1
//#define SDL2

// DEFINE "PANDORA" TO COMPILE FOR IT, ELSE COMPILE FOR DESKTOP.
#define PANDORA

#ifdef PANDORA
#include "eglport.c"
#define set_frustum glFrustumf
#define cleardepth glClearDepthf
#define swap_video_buffer EGL_SwapBuffers();
#define fog_i glFogx
#define ortodox glOrthof(-1.0,1.0,-1.0,1.0,1.0,2.0);
#else
#include "GL/gl.h"
#define set_frustum glFrustum
#define cleardepth glClearDepth
#define swap_video_buffer SDL_GL_SwapBuffers();
#define fog_i glFogi
#define ortodox glOrtho(-1.0,1.0,-1.0,1.0,1.0,2.0);
#endif

using namespace std;

#define pi 3.141592f
#define pi180 0.017453f
#define pi360 0.008726f

int screen_width=800,screen_height=480;
float pixel_to_gl_X=2.0f/screen_width,pixel_to_gl_Y=2.0f/screen_height;
float fps=100.0f;//              DESIRED MAX FPS.

//float dett=0.0f,dtva=0.0f,dtre=0.0f,dfyr=0.0f,dfem=0.0f,dsex=0.0f,mp[16];
float r_fov=45.0f;
float r_aspectRatio=(float)screen_width/screen_height;
float cax=0.0f,cay=0.0f,caz=0.0f,cpx=0.0f,cpy=0.0f,cpz=0.0f,mc[9];
float r1x=0.0f,r1y=0.0f,r1z=0.0f,r2x=0.0f,r2y=0.0f,r2z=0.0f,r3x=0.0f,r3y=0.0f,r3z=0.0f;
unsigned int oldTime=0,currentTime=0,nullTime=0;float ms=0.0f,game_time=0.0f;// TIME.
float xpos=-3.0f,ypos=0.0f,zpos=-3.0f,xa=0.0f,ya=0.0f,hs=0.225f,oxpos=0.0f,oypos=1.5f,ozpos=-2.0f;

// PERSPECTIVE CALCULATION. (FOR GL(ES) 1.0)
void glup(GLfloat fov,GLfloat aspectr,GLfloat zn,GLfloat zf){
float xmin,xmax,ymin,ymax;
ymax=(float)zn*tanf(fov*pi360);
ymin=(float)-ymax;
xmin=(float)ymin*aspectr;
xmax=(float)ymax*aspectr;
set_frustum(xmin,xmax,ymin,ymax,zn,zf);}

// ROTATION MATRIX.
void rotm(float rx,float ry,float rz,float& t1x,float& t1y,float& t1z,float& t2x,float& t2y,
          float& t2z,float& t3x,float& t3y,float& t3z){
    float sx=0.0f,cx=0.0f,sy=0.0f,cy=0.0f,sz=0.0f,cz=0.0f,theta=0.0f;
    theta=rx*0.017453f;sx=sinf(theta);cx=cosf(theta);
    theta=ry*0.017453f;sy=sinf(theta);cy=cosf(theta);
    theta=rz*0.017453f;sz=sinf(theta);cz=cosf(theta);
    t1x=cz*cy-sz*sx*sy;t1y=sz*cy+cz*sx*sy;t1z=-cx*sy;t2x=-sz*cx;
    t2y=cz*cx;t2z=sx;t3x=cz*sy+sz*sx*cy;t3y=sz*sy-cz*sx*cy;t3z=cx*cy;}

// xp + yp = POINT OF ROTATION. ux + uy = POINT TO ROTATE (will be updated) WITH "degree".
void rotate(float xp,float yp,float& ux,float& uy,float degree){
    float bt=0.0f,lx=0.0f,ly=0.0f,rx=0.0f,ry=0.0f,nnx=0.0f,a=0.0f;
    if(uy<=yp&&ux>=xp){a=(float)atanf((yp-uy)/((ux-xp)))*57.295779f;
        lx=(float)ux-xp;ly=(float)yp-uy;}
    if(uy<=yp&&xp>ux){a=(float)90.0f+(90.0f-acosf((xp-ux)/(sqrtf(
        ((yp-uy)*(yp-uy))+((xp-ux)*(xp-ux)))))*57.295779f);lx=(float)xp-ux;ly=(float)yp-uy;}
    if(yp<uy&&xp>ux){a=(float)270.0f-(90.0f-(atanf((uy-yp)/((xp-ux)))*57.295779f));
        lx=(float)xp-ux;ly=(float)uy-yp;}
    if(yp<uy&&ux>=xp){a=(float)360.0f-(acosf((ux-xp)/(sqrtf(
        ((uy-yp)*(uy-yp))+((ux-xp)*(ux-xp)))))*57.295779f);lx=(float)ux-xp;ly=(float)uy-yp;}
    a=(float)((360.0f-a)+degree)+45.0f;
    rx=(float)cosf(a*0.017453f)+sinf(a*0.017453f);
    ry=(float)-sinf(a*0.017453f)+cosf(a*0.017453f);
    nnx=(float)sqrtf((rx*rx)+(ry*ry));bt=(float)sqrtf((lx*lx)+(ly*ly));
    rx=(float)rx/nnx;ry=(float)ry/nnx;ux=(float)xp+(rx*bt);uy=(float)yp-(ry*bt);}


const int number_of_textures = 2;
static GLuint texture[number_of_textures];
static char filentex[number_of_textures][99];

void set_paths(){
strcpy(filentex[0],"wall1.png");
strcpy(filentex[1],"fontc.png");
}

void load_image(char tex_name[99]){unsigned int w=0,h=0;unsigned char* image;
lodepng_decode32_file(&image,&w,&h,tex_name);// lib use here WARNING
glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,w,h,0,GL_RGBA,GL_UNSIGNED_BYTE,image);
free(image);}

#define tex_filter_bilinear 0
#define tex_filter_none 1
int tex_filter=tex_filter_none;
void set_tex_parameters(int tex_par){
if(tex_par==tex_filter_bilinear){
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);}
if(tex_par==tex_filter_none){
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);}
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);}

void change_tex_filter(int type){tex_filter=type;
for(int i=0;i<number_of_textures;i++){
glBindTexture(GL_TEXTURE_2D,texture[i]);
set_tex_parameters(tex_filter);}}

void load_textures(){
set_paths();
glGenTextures(number_of_textures,&texture[0]);
for(int i=0;i<number_of_textures;i++){
glBindTexture(GL_TEXTURE_2D,texture[i]);
set_tex_parameters(tex_filter);load_image(filentex[i]);}}

void free_textures(){glDeleteTextures(number_of_textures,&texture[0]);}





void game_move(float& xp,float& yp,float& zp,int forward,int backward,int left, int right,
               float up,float down,float angle_h,float angle_v,float speed,bool free_float){
float rx=0.0f,ry=0.0f,rad=0.017453f,offset=135.0f,nnx=0.0f,vf=0.0f;
if(angle_v<0.0f){vf=((-90.0f)-(angle_v))/(-90.0f);}else{vf=(90.0f-angle_v)/90.0f;}
if(forward==1){
 rx=cos((angle_h+offset)*rad)+sin((angle_h+offset)*rad);
 ry=-sin((angle_h+offset)*rad)+cos((angle_h+offset)*rad);
 nnx=sqrt((rx*rx)+(ry*ry));rx/=nnx;ry/=nnx;rx*=speed;ry*=speed;
 if(free_float==true){xp-=rx*vf;zp+=ry*vf;
  if(angle_v<=0.0f){yp+=speed*(1.0f-vf);}else{yp-=speed*(1.0f-vf);}}
 else{xp-=rx;zp+=ry;}}
if(backward==1){
 rx=cos((angle_h+offset)*rad)+sin((angle_h+offset)*rad);
 ry=-sin((angle_h+offset)*rad)+cos((angle_h+offset)*rad);
 nnx=sqrt((rx*rx)+(ry*ry));rx/=nnx;ry/=nnx;rx*=speed;ry*=speed;
 if(free_float==true){xp+=rx*vf;zp-=ry*vf;
  if(angle_v<=0.0f){yp-=speed*(1.0f-vf);}else{yp+=speed*(1.0f-vf);}}
 else{xp+=rx;zp-=ry;}}
if(left==1){
 rx=cos((angle_h+offset+90.0f)*rad)+sin((angle_h+offset+90.0f)*rad);
 ry=-sin((angle_h+offset+90.0f)*rad)+cos((angle_h+offset+90.0f)*rad);
 nnx=sqrt((rx*rx)+(ry*ry));rx/=nnx;ry/=nnx;rx*=speed;ry*=speed;xp+=rx;zp-=ry;}
if(right==1){
 rx=cos((angle_h+offset-90.0f)*rad)+sin((angle_h+offset-90.0f)*rad);
 ry=-sin((angle_h+offset-90.0f)*rad)+cos((angle_h+offset-90.0f)*rad);
 nnx=sqrt((rx*rx)+(ry*ry));rx/=nnx;ry/=nnx;rx*=speed;ry*=speed;xp+=rx;zp-=ry;}
if(up==1){yp+=speed;}
if(down==1){yp-=speed;}}




void update_time(unsigned int& utime,unsigned int& otime){unsigned int x;
 x=utime;utime=SDL_GetTicks();if(utime<x){otime=utime;if(otime>8){otime-=8;}else{otime=0;}}}
void delay_time(int utime){SDL_Delay(utime);}


const int maxp=4000;// MAX NUMBER OF POLYGONS TO RENDER AT ONCE.
static float vertice[maxp*18],texture_coordinate[maxp*12],colors[maxp*24];
static int texture_select[maxp*6];int pc=0;
const int maxp_osd=1000;
static float vertice_osd[maxp_osd*18],texture_coordinate_osd[maxp_osd*12],colors_osd[maxp_osd*24];

const int polygon_loading_capacity=maxp*2;
static float rv[polygon_loading_capacity*9];
static float rtc[polygon_loading_capacity*6];
static int rf[polygon_loading_capacity*3];
static int rt[polygon_loading_capacity*3];
static int rtv[polygon_loading_capacity];
FILE * file;

int load_data(){int c=0,d=0,e=0,f=0,g=0,oom=0,tex_val=-1,r=0;char lr[999];
file=fopen("testmap3t.obj","r");while(1){r=fscanf(file,"%s",lr);if(r==EOF)break;
if(strcmp(lr,"usemtl")==0){tex_val+=1;}
if(strcmp(lr,"v")==0){fscanf(file,"%f %f %f\n",&rv[d+0],&rv[d+1],&rv[d+2]);d+=3;}
if(strcmp(lr,"vt")==0){fscanf(file,"%f %f\n",&rtc[e+0],&rtc[e+1]);e+=2;}
if(strcmp(lr,"f")==0){fscanf(file,"%d/%d %d/%d %d/%d\n",
   &rf[f+0],&rt[f+0],&rf[f+1],&rt[f+1],&rf[f+2],&rt[f+2]);rtv[g]=tex_val;f+=3;g+=1;}}
fclose(file);c=0;d=0;e=0;f=0;//g=0;
 while(f<g){
  vertice[c+0]=(float)rv[(rf[d+0]*3)-3];
  vertice[c+1]=(float)rv[(rf[d+0]*3)-2];
  vertice[c+2]=(float)rv[(rf[d+0]*3)-1];
  vertice[c+3]=(float)rv[(rf[d+1]*3)-3];
  vertice[c+4]=(float)rv[(rf[d+1]*3)-2];
  vertice[c+5]=(float)rv[(rf[d+1]*3)-1];
  vertice[c+6]=(float)rv[(rf[d+2]*3)-3];
  vertice[c+7]=(float)rv[(rf[d+2]*3)-2];
  vertice[c+8]=(float)rv[(rf[d+2]*3)-1];
  texture_coordinate[e+0]=(float)rtc[(rt[d+0]*2)-2];
  texture_coordinate[e+1]=(float)rtc[(rt[d+0]*2)-1]*-1.0f;
  texture_coordinate[e+2]=(float)rtc[(rt[d+1]*2)-2];
  texture_coordinate[e+3]=(float)rtc[(rt[d+1]*2)-1]*-1.0f;
  texture_coordinate[e+4]=(float)rtc[(rt[d+2]*2)-2];
  texture_coordinate[e+5]=(float)rtc[(rt[d+2]*2)-1]*-1.0f;
  texture_select[f]=(int)rtv[f];
 c+=9;d+=3;e+=6;f+=1;}
 c=0;d=0;e=0;f=0;return g;
}


static float tv[maxp*9];
static int tvc[maxp];
static float tvd[maxp*3];
static float tvdf[maxp*3];
static float tvdx[maxp*3];
static int tvdi[maxp*3];
static float tt[maxp*6];

const float draw_distance=70.0f,dd_delta=1.0f;

void render(float fxpos,float fypos,float fzpos,float fm_angle_h,
            float fc1,float fc2,float fc3,float fc4){
int x=0;
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 glup(r_fov,r_aspectRatio,0.1f,15.0f);
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();
 
          // CAMERA START
 //glRotatef(m_angle_v,1.0f,0.0f,0.0f); 
 glRotatef(fm_angle_h,0.0f,-1.0f,0.0f);
 glTranslatef(-fxpos,-fypos,fzpos);
         // CAMERA END

fzpos*=-1.0f;

for(int i=0;i<pc;i++){
 colors[(i*12)+0]=fc1;colors[(i*12)+1]=fc2;colors[(i*12)+2]=fc3;colors[(i*12)+3]=fc4;
 colors[(i*12)+4]=fc1;colors[(i*12)+5]=fc2;colors[(i*12)+6]=fc3;colors[(i*12)+7]=fc4;
 colors[(i*12)+8]=fc1;colors[(i*12)+9]=fc2;colors[(i*12)+10]=fc3;colors[(i*12)+11]=fc4;
 tv[(i*9)+0]=vertice[(i*9)+0]-fxpos;if(tv[(i*9)+0]<0.0f){tv[(i*9)+0]*=-1.0f;}
 tv[(i*9)+1]=vertice[(i*9)+1]-fypos;if(tv[(i*9)+1]<0.0f){tv[(i*9)+1]*=-1.0f;}
 tv[(i*9)+2]=vertice[(i*9)+2]-fzpos;if(tv[(i*9)+2]<0.0f){tv[(i*9)+2]*=-1.0f;}
 tv[(i*9)+3]=vertice[(i*9)+3]-fxpos;if(tv[(i*9)+3]<0.0f){tv[(i*9)+3]*=-1.0f;}
 tv[(i*9)+4]=vertice[(i*9)+4]-fypos;if(tv[(i*9)+4]<0.0f){tv[(i*9)+4]*=-1.0f;}
 tv[(i*9)+5]=vertice[(i*9)+5]-fzpos;if(tv[(i*9)+5]<0.0f){tv[(i*9)+5]*=-1.0f;}
 tv[(i*9)+6]=vertice[(i*9)+6]-fxpos;if(tv[(i*9)+6]<0.0f){tv[(i*9)+6]*=-1.0f;}
 tv[(i*9)+7]=vertice[(i*9)+7]-fypos;if(tv[(i*9)+7]<0.0f){tv[(i*9)+7]*=-1.0f;}
 tv[(i*9)+8]=vertice[(i*9)+8]-fzpos;if(tv[(i*9)+8]<0.0f){tv[(i*9)+8]*=-1.0f;}
 tvd[i]=tv[(i*9)+0]+tv[(i*9)+1]+tv[(i*9)+2]+
        tv[(i*9)+3]+tv[(i*9)+4]+tv[(i*9)+5]+
        tv[(i*9)+6]+tv[(i*9)+7]+tv[(i*9)+8];
 if(tvd[i]<draw_distance+dd_delta){tvdx[x]=tvd[i];tvc[x]=i;x+=1;}
 tvdf[i]=-1.0f;tvdi[i]=maxp*3;}

for(int i=0;i<x;i++){for(int j=0;j<x;j++){
 if(tvdx[j]>tvdf[i]){tvdi[i]=j;tvdf[i]=tvdx[j];}}
 tvdx[tvdi[i]]=-1.0f;}

for(int i=0;i<x;i++){
tv[(i*9)+0]=vertice[(tvc[tvdi[i]]*9)+0];
tv[(i*9)+1]=vertice[(tvc[tvdi[i]]*9)+1];
tv[(i*9)+2]=vertice[(tvc[tvdi[i]]*9)+2];
tv[(i*9)+3]=vertice[(tvc[tvdi[i]]*9)+3];
tv[(i*9)+4]=vertice[(tvc[tvdi[i]]*9)+4];
tv[(i*9)+5]=vertice[(tvc[tvdi[i]]*9)+5];
tv[(i*9)+6]=vertice[(tvc[tvdi[i]]*9)+6];
tv[(i*9)+7]=vertice[(tvc[tvdi[i]]*9)+7];
tv[(i*9)+8]=vertice[(tvc[tvdi[i]]*9)+8];
tt[(i*6)+0]=texture_coordinate[(tvc[tvdi[i]]*6)+0];
tt[(i*6)+1]=texture_coordinate[(tvc[tvdi[i]]*6)+1];
tt[(i*6)+2]=texture_coordinate[(tvc[tvdi[i]]*6)+2];
tt[(i*6)+3]=texture_coordinate[(tvc[tvdi[i]]*6)+3];
tt[(i*6)+4]=texture_coordinate[(tvc[tvdi[i]]*6)+4];
tt[(i*6)+5]=texture_coordinate[(tvc[tvdi[i]]*6)+5];
}

glBindTexture(GL_TEXTURE_2D, texture[0]);
glVertexPointer(3,GL_FLOAT,0,tv);
glTexCoordPointer(2,GL_FLOAT,0,tt);
glColorPointer(4,GL_FLOAT,0,colors);
glDrawArrays(GL_TRIANGLES,0,x*3);
}





const int number_of_letters_word=30;
float eR1[number_of_letters_word];
float eG1[number_of_letters_word];
float eB1[number_of_letters_word];
float eA1[number_of_letters_word];
float eR2[number_of_letters_word];
float eG2[number_of_letters_word];
float eB2[number_of_letters_word];
float eA2[number_of_letters_word];
float eR3[number_of_letters_word];
float eG3[number_of_letters_word];
float eB3[number_of_letters_word];
float eA3[number_of_letters_word];
float eR4[number_of_letters_word];
float eG4[number_of_letters_word];
float eB4[number_of_letters_word];
float eA4[number_of_letters_word];



void get_color_g(float& eRs1,float& eGs1,float& eBs1,float& eAs1,
                 float& eRs2,float& eGs2,float& eBs2,float& eAs2,
                 float& eRs3,float& eGs3,float& eBs3,float& eAs3,
                 float& eRs4,float& eGs4,float& eBs4,float& eAs4){
   eRs1=0.0;eGs1=0.82;eBs1=0.0;eAs1=0.6;// LOWER LEFT
   eRs2=0.0;eGs2=0.82;eBs2=0.0;eAs2=0.6;// UPPER LEFT
   eRs3=0.0;eGs3=0.82;eBs3=0.0;eAs3=0.6;// UPPER RIGHT
   eRs4=0.0;eGs4=0.82;eBs4=0.0;eAs4=0.6;}
void get_color_s(float& eRs1,float& eGs1,float& eBs1,float& eAs1,
                 float& eRs2,float& eGs2,float& eBs2,float& eAs2,
                 float& eRs3,float& eGs3,float& eBs3,float& eAs3,
                 float& eRs4,float& eGs4,float& eBs4,float& eAs4){
   eRs1=0.75;eGs1=0.75;eBs1=1.0;eAs1=1.0;// LOWER LEFT
   eRs2=0.88;eGs2=0.88;eBs2=1.0;eAs2=1.0;// UPPER LEFT
   eRs3=0.88;eGs3=0.88;eBs3=1.0;eAs3=1.0;// UPPER RIGHT
   eRs4=0.75;eGs4=0.75;eBs4=1.0;eAs4=1.0;}
void get_color_b(float& eRs1,float& eGs1,float& eBs1,float& eAs1,
                 float& eRs2,float& eGs2,float& eBs2,float& eAs2,
                 float& eRs3,float& eGs3,float& eBs3,float& eAs3,
                 float& eRs4,float& eGs4,float& eBs4,float& eAs4){
   eRs1=0.0;eGs1=0.0;eBs1=0.0;eAs1=1.0;// LOWER LEFT
   eRs2=0.0;eGs2=0.0;eBs2=0.6;eAs2=1.0;// UPPER LEFT
   eRs3=0.0;eGs3=0.0;eBs3=0.6;eAs3=1.0;// UPPER RIGHT
   eRs4=0.0;eGs4=0.0;eBs4=0.0;eAs4=1.0;}
void get_color_w(float& eRs1,float& eGs1,float& eBs1,float& eAs1,
                 float& eRs2,float& eGs2,float& eBs2,float& eAs2,
                 float& eRs3,float& eGs3,float& eBs3,float& eAs3,
                 float& eRs4,float& eGs4,float& eBs4,float& eAs4){
   eRs1=1.0;eGs1=1.0;eBs1=0.75;eAs1=1.0;// LOWER LEFT
   eRs2=1.0;eGs2=1.0;eBs2=1.0;eAs2=1.0;// UPPER LEFT
   eRs3=1.0;eGs3=1.0;eBs3=1.0;eAs3=1.0;// UPPER RIGHT
   eRs4=1.0;eGs4=1.0;eBs4=0.75;eAs4=1.0;}
void get_color_r(float& eRs1,float& eGs1,float& eBs1,float& eAs1,
                 float& eRs2,float& eGs2,float& eBs2,float& eAs2,
                 float& eRs3,float& eGs3,float& eBs3,float& eAs3,
                 float& eRs4,float& eGs4,float& eBs4,float& eAs4){
   eRs1=1.0;eGs1=0.0;eBs1=0.0;eAs1=1.0;// LOWER LEFT
   eRs2=1.0;eGs2=0.0;eBs2=0.0;eAs2=1.0;// UPPER LEFT
   eRs3=1.0;eGs3=0.0;eBs3=0.0;eAs3=1.0;// UPPER RIGHT
   eRs4=1.0;eGs4=0.0;eBs4=0.0;eAs4=1.0;}

//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: DRAW LETTERS.
void draw_char(float posX,float posY,int width,int height,char texs,float depth,int q,
 float r1,float g1,float b1,float a1,
 float r2,float g2,float b2,float a2,
 float r3,float g3,float b3,float a3,
 float r4,float g4,float b4,float a4){
  float sc=0.0,v1x=0.0f,v1y=0.0f,ld=0.0f,lu=0.0f,ll=0.0f,lr=0.0f;
  float ix=1.0/256.0;// (1.0 / IMAGE SIZE).
  // NOW LETS FIND THE UPPER LEFT CORNER OF THE CHARACTER IN THE IMAGE.
  if(texs=='A'){ld=0.0;ll=0.0;}
  if(texs=='B'){ld=0.0;ll=8.0;}
  if(texs=='C'){ld=0.0;ll=16.0;}
  if(texs=='D'){ld=0.0;ll=24.0;}
  if(texs=='E'){ld=0.0;ll=32.0;}
  if(texs=='F'){ld=0.0;ll=40.0;}
  if(texs=='G'){ld=0.0;ll=48.0;}
  if(texs=='H'){ld=0.0;ll=56.0;}
  if(texs=='I'){ld=0.0;ll=66.0;}
  if(texs=='J'){ld=0.0;ll=72.0;}
  if(texs=='K'){ld=0.0;ll=80.0;}
  if(texs=='L'){ld=0.0;ll=88.0;}
  if(texs=='M'){ld=0.0;ll=96.0;}
  if(texs=='N'){ld=0.0;ll=108.0;}
  if(texs=='O'){ld=0.0;ll=118.0;}
  if(texs=='P'){ld=0.0;ll=126.0;}
  if(texs=='Q'){ld=0.0;ll=134.0;}
  if(texs=='R'){ld=0.0;ll=142.0;}
  if(texs=='S'){ld=0.0;ll=150.0;}
  if(texs=='T'){ld=0.0;ll=158.0;}
  if(texs=='U'){ld=0.0;ll=166.0;}
  if(texs=='V'){ld=0.0;ll=174.0;}
  if(texs=='W'){ld=0.0;ll=184.0;}
  if(texs=='X'){ld=0.0;ll=196.0;}
  if(texs=='Y'){ld=0.0;ll=206.0;}
  if(texs=='Z'){ld=0.0;ll=214.0;}
  if(texs=='@'){ld=0.0;ll=222.0;}
  //if(texs=='½'){ld=0.0*ix;ll=234.0*ix;}
  if(texs=='^'){ld=0.0;ll=242.0;}
  if(texs=='0'){ld=12.0;ll=0.0;}
  if(texs=='1'){ld=12.0;ll=8.0;}
  if(texs=='2'){ld=12.0;ll=14.0;}
  if(texs=='3'){ld=12.0;ll=22.0;}
  if(texs=='4'){ld=12.0;ll=30.0;}
  if(texs=='5'){ld=12.0;ll=38.0;}
  if(texs=='6'){ld=12.0;ll=46.0;}
  if(texs=='7'){ld=12.0;ll=54.0;}
  if(texs=='8'){ld=12.0;ll=62.0;}
  if(texs=='9'){ld=12.0;ll=70.0;}
  if(texs=='!'){ld=12.0;ll=79.0;}
  if(texs=='?'){ld=12.0;ll=84.0;}
  if(texs=='.'){ld=12.0;ll=93.0;}
  if(texs==','){ld=12.0;ll=99.0;}
  if(texs=='-'){ld=12.0;ll=104.0;}
  if(texs=='+'){ld=12.0;ll=112.0;}
  if(texs=='='){ld=12.0;ll=120.0;}
  if(texs=='/'){ld=12.0;ll=128.0;}
  if(texs=='*'){ld=12.0;ll=137.0;}
  //if(texs=='§'){ld=12.0*ix;ll=144.0*ix;}
  if(texs==':'){ld=12.0;ll=158.0;}
  if(texs==';'){ld=12.0;ll=163.0;}
  if(texs=='_'){ld=12.0;ll=168.0;}
  if(texs=='\''){ld=12.0;ll=176.0;}
  if(texs=='('){ld=12.0;ll=180.0;}
  if(texs==')'){ld=12.0;ll=185.0;}
  if(texs=='['){ld=12.0;ll=190.0;}
  if(texs==']'){ld=12.0;ll=195.0;}
  if(texs=='{'){ld=12.0;ll=200.0;}
  if(texs=='}'){ld=12.0;ll=205.0;}
  if(texs=='\\'){ld=12.0;ll=210.0;}
  if(texs=='&'){ld=12.0;ll=218.0;}
  if(texs=='%'){ld=12.0;ll=227.0;}
  if(texs=='#'){ld=12.0;ll=235.0;}
  if(texs=='"'){ld=12.0;ll=244.0;}
  if(texs=='a'){ld=24.0;ll=0.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='b'){ld=24.0;ll=10.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='c'){ld=24.0;ll=18.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='d'){ld=24.0;ll=25.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='e'){ld=24.0;ll=34.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='f'){ld=24.0;ll=42.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='g'){ld=24.0;ll=48.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='h'){ld=24.0;ll=56.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='i'){ld=24.0;ll=64.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='j'){ld=24.0;ll=68.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='k'){ld=24.0;ll=73.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='l'){ld=24.0;ll=81.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='m'){ld=24.0;ll=85.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='n'){ld=24.0;ll=96.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='o'){ld=24.0;ll=104.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='p'){ld=24.0;ll=112.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='q'){ld=24.0;ll=120.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='r'){ld=24.0;ll=128.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='s'){ld=24.0;ll=135.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='t'){ld=24.0;ll=141.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='u'){ld=24.0;ll=148.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='v'){ld=24.0;ll=156.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='w'){ld=24.0;ll=164.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='x'){ld=24.0;ll=174.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='y'){ld=24.0;ll=181.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='z'){ld=24.0;ll=188.0;sc=3.0*pixel_to_gl_Y;}
  if(texs=='<'){ld=24.0;ll=197.0;}
  if(texs=='>'){ld=24.0;ll=204.0;}
  if(texs=='$'){ld=24.0;ll=211.0;}
  //if(texs=='€'){ld=24.0*ix;ll=219.0*ix;}
  //if(texs=='£'){ld=24.0*ix;ll=227.0*ix;}
  if(texs=='|'){ld=24.0;ll=237.0;}
  if(texs==' '){ld=24.0;ll=241.0;}
  lu=(ld+height)*ix;lr=(ll+width)*ix;ld*=ix;ll*=ix;// ADD LOWER RIGHT CORNER COORDINATE.
  v1x=width*pixel_to_gl_X;v1y=height*pixel_to_gl_Y;
   vertice_osd[(q*18)+0]=posX;     vertice_osd[(q*18)+1]=posY-sc;       vertice_osd[(q*18)+2]=depth;
   vertice_osd[(q*18)+3]=posX+v1x; vertice_osd[(q*18)+4]=posY-sc;       vertice_osd[(q*18)+5]=depth;
   vertice_osd[(q*18)+6]=posX;     vertice_osd[(q*18)+7]=(posY+v1y)-sc; vertice_osd[(q*18)+8]=depth;
   vertice_osd[(q*18)+9]= posX;    vertice_osd[(q*18)+10]=(posY+v1y)-sc;vertice_osd[(q*18)+11]=depth;
   vertice_osd[(q*18)+12]=posX+v1x;vertice_osd[(q*18)+13]=posY-sc;      vertice_osd[(q*18)+14]=depth;
   vertice_osd[(q*18)+15]=posX+v1x;vertice_osd[(q*18)+16]=(posY+v1y)-sc;vertice_osd[(q*18)+17]=depth;
   texture_coordinate_osd[(q*12)+0]=ll; texture_coordinate_osd[(q*12)+1]=lu;
   texture_coordinate_osd[(q*12)+2]=lr; texture_coordinate_osd[(q*12)+3]=lu;
   texture_coordinate_osd[(q*12)+4]=ll; texture_coordinate_osd[(q*12)+5]=ld;
   texture_coordinate_osd[(q*12)+6]=ll; texture_coordinate_osd[(q*12)+7]=ld;
   texture_coordinate_osd[(q*12)+8]=lr; texture_coordinate_osd[(q*12)+9]=lu;
   texture_coordinate_osd[(q*12)+10]=lr;texture_coordinate_osd[(q*12)+11]=ld;
   colors_osd[(q*24)+0]=r1; colors_osd[(q*24)+1]=g1; 
   colors_osd[(q*24)+2]=b1; colors_osd[(q*24)+3]=a1;// LOWER LEFT
   colors_osd[(q*24)+4]=r4; colors_osd[(q*24)+5]=g4; 
   colors_osd[(q*24)+6]=b4; colors_osd[(q*24)+7]=a4;// LOWER RIGHT
   colors_osd[(q*24)+8]=r2; colors_osd[(q*24)+9]=g2; 
   colors_osd[(q*24)+10]=b2;colors_osd[(q*24)+11]=a2;// UPPER LEFT
   colors_osd[(q*24)+12]=r3;colors_osd[(q*24)+13]=g3;
   colors_osd[(q*24)+14]=b3;colors_osd[(q*24)+15]=a3;// UPPER RIGHT
   colors_osd[(q*24)+16]=r2;colors_osd[(q*24)+17]=g2;
   colors_osd[(q*24)+18]=b2;colors_osd[(q*24)+19]=a2;// UPPER LEFT
   colors_osd[(q*24)+20]=r4;colors_osd[(q*24)+21]=g4;
   colors_osd[(q*24)+22]=b4;colors_osd[(q*24)+23]=a4;// LOWER RIGHT
}

void printl(char *messp,float startx,float starty,int fDEPTH,
float fR1[number_of_letters_word],float fR2[number_of_letters_word],
float fR3[number_of_letters_word],float fR4[number_of_letters_word],
float fG1[number_of_letters_word],float fG2[number_of_letters_word],
float fG3[number_of_letters_word],float fG4[number_of_letters_word],
float fB1[number_of_letters_word],float fB2[number_of_letters_word],
float fB3[number_of_letters_word],float fB4[number_of_letters_word],
float fA1[number_of_letters_word],float fA2[number_of_letters_word],
float fA3[number_of_letters_word],float fA4[number_of_letters_word]){
char messt;float sx=0.0,startxmod=0.0,tx=0.0f,ty=0.0f;int fc=0;
while(messp[fc]!='\0'){messt=messp[fc];
  // SIZE CHART.
  if(messt=='A'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='B'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='C'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='D'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='E'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='F'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='G'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='H'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='I'){tx=4.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='J'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='K'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='L'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='M'){tx=12.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='N'){tx=10.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='O'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='P'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='Q'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='R'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='S'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='T'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='U'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='V'){tx=10.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='W'){tx=12.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='X'){tx=10.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='Y'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='Z'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='a'){tx=10.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='b'){tx=8.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='c'){tx=7.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='d'){tx=9.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='e'){tx=8.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='f'){tx=6.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='g'){tx=8.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='h'){tx=8.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='i'){tx=4.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='j'){tx=5.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='k'){tx=8.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='l'){tx=4.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='m'){tx=11.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='n'){tx=8.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='o'){tx=8.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='p'){tx=8.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='q'){tx=8.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='r'){tx=7.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='s'){tx=6.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='t'){tx=7.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='u'){tx=8.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='v'){tx=8.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='w'){tx=10.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='x'){tx=7.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='y'){tx=7.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt=='z'){tx=7.0;ty=15.0;sx=tx*pixel_to_gl_X;}
  if(messt==' '){tx=6.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='0'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='1'){tx=6.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='2'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='3'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='4'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='5'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='6'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='7'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='8'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='9'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='!'){tx=4.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='?'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='.'){tx=4.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt==','){tx=4.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='-'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='+'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='='){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='/'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='*'){tx=6.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='@'){tx=12.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='"'){tx=7.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='#'){tx=9.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  //if(messt=='£'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}// blanked out letters ASCII code dont fit inside char.
  if(messt=='$'){tx=7.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  //if(messt=='€'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='%'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='&'){tx=9.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='{'){tx=5.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='}'){tx=5.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='('){tx=5.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt==')'){tx=5.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='['){tx=5.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt==']'){tx=5.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='\\'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='^'){tx=7.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='\''){tx=4.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='<'){tx=7.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='>'){tx=7.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='|'){tx=4.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt==';'){tx=4.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt==':'){tx=4.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  if(messt=='_'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  //if(messt=='½'){tx=8.0;ty=12.0;sx=tx*pixel_to_gl_X;}
  //if(messt=='§'){tx=11.0;ty=12.0;sx=tx*pixel_to_gl_X;}// USE THIS FOR STAR
  draw_char(startx+startxmod,starty,tx,ty,messt,fDEPTH,fc,
            fR1[fc],fG1[fc],fB1[fc],fA1[fc],fR2[fc],fG2[fc],fB2[fc],fA2[fc],
            fR3[fc],fG3[fc],fB3[fc],fA3[fc],fR4[fc],fG4[fc],fB4[fc],fA4[fc]);
  startxmod+=sx;fc+=1;}
glBindTexture(GL_TEXTURE_2D, texture[1]);
glVertexPointer(3,GL_FLOAT,0,vertice_osd);
glTexCoordPointer(2,GL_FLOAT,0,texture_coordinate_osd);
glColorPointer(4,GL_FLOAT,0,colors_osd);
glDrawArrays(GL_TRIANGLES,0,fc*6);
fc=0;}

char temp[15];
char hmc0[]="FPS 0000";const int e_create_new_bone=0;

void render_osd(){

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  ortodox
  glDisable(GL_DEPTH_TEST);

//::::::::::::::::::: F P S   M E T E R ::::::::::::::::::::::::::::::
for(int i=0;i<9;i++){
get_color_g(eR1[i],eG1[i],eB1[i],eA1[i],eR2[i],eG2[i],eB2[i],eA2[i],
            eR3[i],eG3[i],eB3[i],eA3[i],eR4[i],eG4[i],eB4[i],eA4[i]);}
printl(hmc0,0.8f,0.8f,-1.5f,
 eR1,eR2,eR3,eR4,eG1,eG2,eG3,eG4,eB1,eB2,eB3,eB4,eA1,eA2,eA3,eA4);
//::::::::::::::::::: F P S   M E T E R ::::::::::::::::::::::::::::::

glEnable(GL_DEPTH_TEST);
}


static int cd_ref_player[maxp/2];int current_floor=0,cd_ref_now[5]={0,0,0,0,0};
static float brute_wall[6][maxp/2][6];fstream tfile;int number_of_walls=0;
void set_walls(int map){int x=0;float delta=0.3f;
  if(map==1){
  tfile.open("testmap3t-f1.txt");
  tfile>>x;
  cd_ref_now[0]=x;
  for(int i=0;i<x;i++){
  tfile>>brute_wall[0][i][0];
  tfile>>brute_wall[0][i][1];
  tfile>>brute_wall[0][i][2];
  tfile>>brute_wall[0][i][3];
  tfile>>brute_wall[0][i][4];// NORMAL
  tfile>>brute_wall[0][i][5];// height
  brute_wall[0][i][1]*=-1.0f;
  brute_wall[0][i][3]*=-1.0f;}
  tfile.close();
  tfile.open("testmap3t-f2.txt");
  tfile>>x;
  cd_ref_now[1]=x;
  for(int i=0;i<x;i++){
  tfile>>brute_wall[1][i][0];
  tfile>>brute_wall[1][i][1];
  tfile>>brute_wall[1][i][2];
  tfile>>brute_wall[1][i][3];
  tfile>>brute_wall[1][i][4];// NORMAL
  tfile>>brute_wall[1][i][5];// height
  brute_wall[1][i][1]*=-1.0f;
  brute_wall[1][i][3]*=-1.0f;}
  tfile.close();
  tfile.open("testmap3t-f3.txt");
  tfile>>x;
  cd_ref_now[2]=x;
  for(int i=0;i<x;i++){
  tfile>>brute_wall[2][i][0];
  tfile>>brute_wall[2][i][1];
  tfile>>brute_wall[2][i][2];
  tfile>>brute_wall[2][i][3];
  tfile>>brute_wall[2][i][4];// NORMAL
  tfile>>brute_wall[2][i][5];// height
  brute_wall[2][i][1]*=-1.0f;
  brute_wall[2][i][3]*=-1.0f;}
  tfile.close();
  tfile.open("testmap3t-f4.txt");
  tfile>>x;
  cd_ref_now[3]=x;
  for(int i=0;i<x;i++){
  tfile>>brute_wall[3][i][0];
  tfile>>brute_wall[3][i][1];
  tfile>>brute_wall[3][i][2];
  tfile>>brute_wall[3][i][3];
  tfile>>brute_wall[3][i][4];// NORMAL
  tfile>>brute_wall[3][i][5];// height
  brute_wall[3][i][1]*=-1.0f;
  brute_wall[3][i][3]*=-1.0f;}
  tfile.close();
  tfile.open("testmap3t-f5.txt");
  tfile>>x;
  cd_ref_now[4]=x;
  for(int i=0;i<x;i++){
  tfile>>brute_wall[4][i][0];
  tfile>>brute_wall[4][i][1];
  tfile>>brute_wall[4][i][2];
  tfile>>brute_wall[4][i][3];
  tfile>>brute_wall[4][i][4];// NORMAL
  tfile>>brute_wall[4][i][5];// height
  brute_wall[4][i][1]*=-1.0f;
  brute_wall[4][i][3]*=-1.0f;}
  tfile.close();
  }
}


int get_cd(int c){int x=0;float tx=0.0f,tz=0.0f,tt=0.0f;
 for(int i=0;i<c;i++){
  if(brute_wall[current_floor][i][4]<6){
   tx=xpos-brute_wall[current_floor][i][0];
   tz=zpos-brute_wall[current_floor][i][1];
   if(tx<0.0f){tx*=-1.0f;}
   if(tz<0.0f){tz*=-1.0f;}
   tt=tx+tz;
   tx=xpos-brute_wall[current_floor][i][2];
   tz=zpos-brute_wall[current_floor][i][3];
   if(tx<0.0f){tx*=-1.0f;}
   if(tz<0.0f){tz*=-1.0f;}
   tt=tx+tz+tt;
   if(tt<10.0f){cd_ref_player[x]=i;x+=1;}
}}return x;}

void colission_detection_player(int c){int i=0;
float pT=0.0f,delta=0.225f,delta2=0.17f,delta3=0.425f;
for(int j=0;j<c;j++){i=cd_ref_player[j];
if(brute_wall[current_floor][i][4]==1.0f){
 if(xpos+delta>=brute_wall[current_floor][i][0]&&
    oxpos+delta2<brute_wall[current_floor][i][0]){
 pT=(float)zpos+((zpos-ozpos)*((xpos-brute_wall[current_floor][i][0])/(xpos-oxpos)));
 if((pT+delta3>brute_wall[current_floor][i][1]&&
     pT+delta3<brute_wall[current_floor][i][3])||
    (pT+delta3>brute_wall[current_floor][i][3]&&
     pT+delta3<brute_wall[current_floor][i][1])||
    (pT-delta3>brute_wall[current_floor][i][1]&&
     pT-delta3<brute_wall[current_floor][i][3])||
    (pT-delta3>brute_wall[current_floor][i][3]&&
     pT-delta3<brute_wall[current_floor][i][1])){
   if(ypos<=brute_wall[current_floor][i][5]&&ypos>=(float)(current_floor*3.0f)-0.4f){
   xpos=brute_wall[current_floor][i][0]-delta;}}}}
if(brute_wall[current_floor][i][4]==2.0f){
 if(xpos-delta<=brute_wall[current_floor][i][0]&&
   oxpos-delta2>brute_wall[current_floor][i][0]){
 pT=(float)zpos+((zpos-ozpos)*((brute_wall[current_floor][i][0]-xpos)/(oxpos-xpos)));
 if((pT+delta3>brute_wall[current_floor][i][1]&&
     pT+delta3<brute_wall[current_floor][i][3])||
    (pT+delta3>brute_wall[current_floor][i][3]&&
     pT+delta3<brute_wall[current_floor][i][1])||
    (pT-delta3>brute_wall[current_floor][i][1]&&
     pT-delta3<brute_wall[current_floor][i][3])||
    (pT-delta3>brute_wall[current_floor][i][3]&&
     pT-delta3<brute_wall[current_floor][i][1])){
   if(ypos<=brute_wall[current_floor][i][5]&&ypos>=(float)(current_floor*3.0f)-0.4f){
   xpos=brute_wall[current_floor][i][0]+delta;}}}}
if(brute_wall[current_floor][i][4]==3.0f){
 if(zpos-delta<=brute_wall[current_floor][i][1]&&
   ozpos-delta2>brute_wall[current_floor][i][1]){
 pT=(float)xpos+((xpos-oxpos)*((brute_wall[current_floor][i][1]-zpos)/(ozpos-zpos)));
 if((pT+delta3>brute_wall[current_floor][i][0]&&
     pT+delta3<brute_wall[current_floor][i][2])||
    (pT+delta3>brute_wall[current_floor][i][2]&&
     pT+delta3<brute_wall[current_floor][i][0])||
    (pT-delta3>brute_wall[current_floor][i][0]&&
     pT-delta3<brute_wall[current_floor][i][2])||
    (pT-delta3>brute_wall[current_floor][i][2]&&
     pT-delta3<brute_wall[current_floor][i][0])){
   if(ypos<=brute_wall[current_floor][i][5]&&ypos>=(float)(current_floor*3.0f)-0.4f){
   zpos=brute_wall[current_floor][i][1]+delta;}}}}
if(brute_wall[current_floor][i][4]==4.0f){
 if(zpos+delta>=brute_wall[current_floor][i][1]&&
   ozpos+delta2<brute_wall[current_floor][i][1]){
 pT=(float)xpos+((xpos-oxpos)*((zpos-brute_wall[current_floor][i][1])/(zpos-ozpos)));
 if((pT+delta3>brute_wall[current_floor][i][0]&&
     pT+delta3<brute_wall[current_floor][i][2])||
    (pT+delta3>brute_wall[current_floor][i][2]&&
     pT+delta3<brute_wall[current_floor][i][0])||
    (pT-delta3>brute_wall[current_floor][i][0]&&
     pT-delta3<brute_wall[current_floor][i][2])||
    (pT-delta3>brute_wall[current_floor][i][2]&&
     pT-delta3<brute_wall[current_floor][i][0])){
   if(ypos<=brute_wall[current_floor][i][5]&&ypos>=(float)(current_floor*3.0f)-0.4f){
   zpos=brute_wall[current_floor][i][1]-delta;}}}}
if(brute_wall[current_floor][i][4]==5.0f){
 if(brute_wall[current_floor][i][0]>
    brute_wall[current_floor][i][2]){
  if(xpos>=brute_wall[current_floor][i][2]&&
     xpos<=brute_wall[current_floor][i][0]){
   if(brute_wall[current_floor][i][1]>
      brute_wall[current_floor][i][3]){
    if(zpos>=brute_wall[current_floor][i][3]&&
       zpos<=brute_wall[current_floor][i][1]){
     if(ypos>=brute_wall[current_floor][i][5]-0.4f&&
        brute_wall[current_floor][i][5]>ypos){
      ypos=brute_wall[current_floor][i][5];}}}
   else{
    if(zpos>=brute_wall[current_floor][i][1]&&
       zpos<=brute_wall[current_floor][i][3]){
     if(ypos>=brute_wall[current_floor][i][5]-0.4f&&
        brute_wall[current_floor][i][5]>ypos){
      ypos=brute_wall[current_floor][i][5];}}}
  }}
 else{
  if(xpos>=brute_wall[current_floor][i][0]&&
     xpos<=brute_wall[current_floor][i][2]){
   if(brute_wall[current_floor][i][1]>
      brute_wall[current_floor][i][3]){
    if(zpos>=brute_wall[current_floor][i][3]&&
       zpos<=brute_wall[current_floor][i][1]){
     if(ypos>=brute_wall[current_floor][i][5]-0.4f&&
        brute_wall[current_floor][i][5]>ypos){
      ypos=brute_wall[current_floor][i][5];}}}
   else{
    if(zpos>=brute_wall[current_floor][i][1]&&
       zpos<=brute_wall[current_floor][i][3]){
     if(ypos>=brute_wall[current_floor][i][5]-0.4f&&
        brute_wall[current_floor][i][5]>ypos){
      ypos=brute_wall[current_floor][i][5];}}}
  }}
}
}
}


int check_for_event(SDL_Event& x){int status=0;
 if(SDL_PollEvent(&x)){status=1;}else{status=0;}
 if(x.type == SDL_QUIT){status=2;}
return status;}


int key[256]={0};
#define k_ESCAPE 0
#define k_SPACE 1
#define k_UP 2
#define k_DOWN 3
#define k_LEFT 4
#define k_RIGHT 5
#define k_a 6
#define k_b 7
#define k_c 8
#define k_d 9
#define k_e 10
#define k_f 11
#define k_g 12
#define k_h 13
#define k_i 14
#define k_j 15
#define k_k 16
#define k_l 17
#define k_m 18
#define k_n 19
#define k_o 20
#define k_p 21
#define k_q 22
#define k_r 23
#define k_s 24
#define k_t 25
#define k_u 26
#define k_v 27
#define k_w 28
#define k_x 29
#define k_y 30
#define k_z 31
#define k_1 32
#define k_2 33
#define k_3 34
#define k_4 35
#define k_5 36
#define k_6 37
#define k_7 38
#define k_8 39
#define k_9 40
#define k_0 41
#define k_RETURN 42
#define k_MINUS 43
#define k_LSHIFT 44
#define k_RSHIFT 45
#define k_LCTRL 46
#define k_RCTRL 47

void update_keyboard_state(){const Uint8* currentKeyStates;
#ifdef SDL1
currentKeyStates = SDL_GetKeyState( NULL );
if( currentKeyStates[SDLK_ESCAPE] ){key[k_ESCAPE]=1;}else{key[k_ESCAPE]=0;}
if( currentKeyStates[SDLK_SPACE] ){key[k_SPACE]=1;}else{key[k_SPACE]=0;}
if( currentKeyStates[SDLK_UP] ){key[k_UP]=1;}else{key[k_UP]=0;}
if( currentKeyStates[SDLK_DOWN] ){key[k_DOWN]=1;}else{key[k_DOWN]=0;}
if( currentKeyStates[SDLK_LEFT] ){key[k_LEFT]=1;}else{key[k_LEFT]=0;}
if( currentKeyStates[SDLK_RIGHT] ){key[k_RIGHT]=1;}else{key[k_RIGHT]=0;}
if( currentKeyStates[SDLK_a] ){key[k_a]=1;}else{key[k_a]=0;}
if( currentKeyStates[SDLK_b] ){key[k_b]=1;}else{key[k_b]=0;}
if( currentKeyStates[SDLK_c] ){key[k_c]=1;}else{key[k_c]=0;}
if( currentKeyStates[SDLK_d] ){key[k_d]=1;}else{key[k_d]=0;}
if( currentKeyStates[SDLK_e] ){key[k_e]=1;}else{key[k_e]=0;}
if( currentKeyStates[SDLK_f] ){key[k_f]=1;}else{key[k_f]=0;}
if( currentKeyStates[SDLK_g] ){key[k_g]=1;}else{key[k_g]=0;}
if( currentKeyStates[SDLK_h] ){key[k_h]=1;}else{key[k_h]=0;}
if( currentKeyStates[SDLK_i] ){key[k_i]=1;}else{key[k_i]=0;}
if( currentKeyStates[SDLK_j] ){key[k_j]=1;}else{key[k_j]=0;}
if( currentKeyStates[SDLK_k] ){key[k_k]=1;}else{key[k_k]=0;}
if( currentKeyStates[SDLK_l] ){key[k_l]=1;}else{key[k_l]=0;}
if( currentKeyStates[SDLK_m] ){key[k_m]=1;}else{key[k_m]=0;}
if( currentKeyStates[SDLK_n] ){key[k_n]=1;}else{key[k_n]=0;}
if( currentKeyStates[SDLK_o] ){key[k_o]=1;}else{key[k_o]=0;}
if( currentKeyStates[SDLK_p] ){key[k_p]=1;}else{key[k_p]=0;}
if( currentKeyStates[SDLK_q] ){key[k_q]=1;}else{key[k_q]=0;}
if( currentKeyStates[SDLK_r] ){key[k_r]=1;}else{key[k_r]=0;}
if( currentKeyStates[SDLK_s] ){key[k_s]=1;}else{key[k_s]=0;}
if( currentKeyStates[SDLK_t] ){key[k_t]=1;}else{key[k_t]=0;}
if( currentKeyStates[SDLK_u] ){key[k_u]=1;}else{key[k_u]=0;}
if( currentKeyStates[SDLK_v] ){key[k_v]=1;}else{key[k_v]=0;}
if( currentKeyStates[SDLK_w] ){key[k_w]=1;}else{key[k_w]=0;}
if( currentKeyStates[SDLK_x] ){key[k_x]=1;}else{key[k_x]=0;}
if( currentKeyStates[SDLK_y] ){key[k_y]=1;}else{key[k_y]=0;}
if( currentKeyStates[SDLK_z] ){key[k_z]=1;}else{key[k_z]=0;}
if( currentKeyStates[SDLK_1] ){key[k_1]=1;}else{key[k_1]=0;}
if( currentKeyStates[SDLK_2] ){key[k_2]=1;}else{key[k_2]=0;}
if( currentKeyStates[SDLK_3] ){key[k_3]=1;}else{key[k_3]=0;}
if( currentKeyStates[SDLK_4] ){key[k_4]=1;}else{key[k_4]=0;}
if( currentKeyStates[SDLK_5] ){key[k_5]=1;}else{key[k_5]=0;}
if( currentKeyStates[SDLK_6] ){key[k_6]=1;}else{key[k_6]=0;}
if( currentKeyStates[SDLK_7] ){key[k_7]=1;}else{key[k_7]=0;}
if( currentKeyStates[SDLK_8] ){key[k_8]=1;}else{key[k_8]=0;}
if( currentKeyStates[SDLK_9] ){key[k_9]=1;}else{key[k_9]=0;}
if( currentKeyStates[SDLK_0] ){key[k_0]=1;}else{key[k_0]=0;}
if( currentKeyStates[SDLK_RETURN] ){key[k_RETURN]=1;}else{key[k_RETURN]=0;}
if( currentKeyStates[SDLK_MINUS] ){key[k_MINUS]=1;}else{key[k_MINUS]=0;}
if( currentKeyStates[SDLK_LSHIFT] ){key[k_LSHIFT]=1;}else{key[k_LSHIFT]=0;}
if( currentKeyStates[SDLK_RSHIFT] ){key[k_RSHIFT]=1;}else{key[k_RSHIFT]=0;}
if( currentKeyStates[SDLK_LCTRL] ){key[k_LCTRL]=1;}else{key[k_LCTRL]=0;}
if( currentKeyStates[SDLK_RCTRL] ){key[k_RCTRL]=1;}else{key[k_RCTRL]=0;}
#endif
#ifdef SDL2
currentKeyStates = SDL_GetKeyboardState( NULL );
if( currentKeyStates[SDL_SCANCODE_ESCAPE] ){key[k_ESCAPE]=1;}else{key[k_ESCAPE]=0;}
if( currentKeyStates[SDL_SCANCODE_SPACE] ){key[k_SPACE]=1;}else{key[k_SPACE]=0;}
if( currentKeyStates[SDL_SCANCODE_UP] ){key[k_UP]=1;}else{key[k_UP]=0;}
if( currentKeyStates[SDL_SCANCODE_DOWN] ){key[k_DOWN]=1;}else{key[k_DOWN]=0;}
if( currentKeyStates[SDL_SCANCODE_LEFT] ){key[k_LEFT]=1;}else{key[k_LEFT]=0;}
if( currentKeyStates[SDL_SCANCODE_RIGHT] ){key[k_RIGHT]=1;}else{key[k_RIGHT]=0;}
if( currentKeyStates[SDL_SCANCODE_A] ){key[k_a]=1;}else{key[k_a]=0;}
if( currentKeyStates[SDL_SCANCODE_B] ){key[k_b]=1;}else{key[k_b]=0;}
if( currentKeyStates[SDL_SCANCODE_C] ){key[k_c]=1;}else{key[k_c]=0;}
if( currentKeyStates[SDL_SCANCODE_D] ){key[k_d]=1;}else{key[k_d]=0;}
if( currentKeyStates[SDL_SCANCODE_E] ){key[k_e]=1;}else{key[k_e]=0;}
if( currentKeyStates[SDL_SCANCODE_F] ){key[k_f]=1;}else{key[k_f]=0;}
if( currentKeyStates[SDL_SCANCODE_G] ){key[k_g]=1;}else{key[k_g]=0;}
if( currentKeyStates[SDL_SCANCODE_H] ){key[k_h]=1;}else{key[k_h]=0;}
if( currentKeyStates[SDL_SCANCODE_I] ){key[k_i]=1;}else{key[k_i]=0;}
if( currentKeyStates[SDL_SCANCODE_J] ){key[k_j]=1;}else{key[k_j]=0;}
if( currentKeyStates[SDL_SCANCODE_K] ){key[k_k]=1;}else{key[k_k]=0;}
if( currentKeyStates[SDL_SCANCODE_L] ){key[k_l]=1;}else{key[k_l]=0;}
if( currentKeyStates[SDL_SCANCODE_M] ){key[k_m]=1;}else{key[k_m]=0;}
if( currentKeyStates[SDL_SCANCODE_N] ){key[k_n]=1;}else{key[k_n]=0;}
if( currentKeyStates[SDL_SCANCODE_O] ){key[k_o]=1;}else{key[k_o]=0;}
if( currentKeyStates[SDL_SCANCODE_P] ){key[k_p]=1;}else{key[k_p]=0;}
if( currentKeyStates[SDL_SCANCODE_Q] ){key[k_q]=1;}else{key[k_q]=0;}
if( currentKeyStates[SDL_SCANCODE_R] ){key[k_r]=1;}else{key[k_r]=0;}
if( currentKeyStates[SDL_SCANCODE_S] ){key[k_s]=1;}else{key[k_s]=0;}
if( currentKeyStates[SDL_SCANCODE_T] ){key[k_t]=1;}else{key[k_t]=0;}
if( currentKeyStates[SDL_SCANCODE_U] ){key[k_u]=1;}else{key[k_u]=0;}
if( currentKeyStates[SDL_SCANCODE_V] ){key[k_v]=1;}else{key[k_v]=0;}
if( currentKeyStates[SDL_SCANCODE_W] ){key[k_w]=1;}else{key[k_w]=0;}
if( currentKeyStates[SDL_SCANCODE_X] ){key[k_x]=1;}else{key[k_x]=0;}
if( currentKeyStates[SDL_SCANCODE_Y] ){key[k_y]=1;}else{key[k_y]=0;}
if( currentKeyStates[SDL_SCANCODE_Z] ){key[k_z]=1;}else{key[k_z]=0;}
if( currentKeyStates[SDL_SCANCODE_1] ){key[k_1]=1;}else{key[k_1]=0;}
if( currentKeyStates[SDL_SCANCODE_2] ){key[k_2]=1;}else{key[k_2]=0;}
if( currentKeyStates[SDL_SCANCODE_3] ){key[k_3]=1;}else{key[k_3]=0;}
if( currentKeyStates[SDL_SCANCODE_4] ){key[k_4]=1;}else{key[k_4]=0;}
if( currentKeyStates[SDL_SCANCODE_5] ){key[k_5]=1;}else{key[k_5]=0;}
if( currentKeyStates[SDL_SCANCODE_6] ){key[k_6]=1;}else{key[k_6]=0;}
if( currentKeyStates[SDL_SCANCODE_7] ){key[k_7]=1;}else{key[k_7]=0;}
if( currentKeyStates[SDL_SCANCODE_8] ){key[k_8]=1;}else{key[k_8]=0;}
if( currentKeyStates[SDL_SCANCODE_9] ){key[k_9]=1;}else{key[k_9]=0;}
if( currentKeyStates[SDL_SCANCODE_0] ){key[k_0]=1;}else{key[k_0]=0;}
if( currentKeyStates[SDL_SCANCODE_RETURN] ){key[k_RETURN]=1;}else{key[k_RETURN]=0;}
if( currentKeyStates[SDL_SCANCODE_MINUS] ){key[k_MINUS]=1;}else{key[k_MINUS]=0;}
if( currentKeyStates[SDL_SCANCODE_LSHIFT] ){key[k_LSHIFT]=1;}else{key[k_LSHIFT]=0;}
if( currentKeyStates[SDL_SCANCODE_RSHIFT] ){key[k_RSHIFT]=1;}else{key[k_RSHIFT]=0;}
if( currentKeyStates[SDL_SCANCODE_LCTRL] ){key[k_LCTRL]=1;}else{key[k_LCTRL]=0;}
if( currentKeyStates[SDL_SCANCODE_RCTRL] ){key[k_RCTRL]=1;}else{key[k_RCTRL]=0;}
#endif
}





int main(){
  SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER);
  
#ifdef PANDORA
EGL_Open();
SDL_Surface* sl1=SDL_SetVideoMode(800,480,24,SDL_SWSURFACE|SDL_FULLSCREEN);
EGL_Init();
#else
SDL_Surface* sl1=SDL_SetVideoMode(800,480,24,SDL_HWSURFACE|SDL_OPENGL|SDL_DOUBLEBUF);
#endif
  
 glClearColor(0.0f,0.0f,0.0f,0.0f);
 cleardepth(1.0f);
 glDepthFunc(GL_LEQUAL);
 glEnable(GL_DEPTH_TEST);
 glCullFace(GL_BACK);
 glEnable(GL_CULL_FACE);
 glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
 glEnable(GL_BLEND);
 GLfloat fc[4]={0.0f,0.0f,0.0f,1.0f},fd=1.0f,fs=3.0f,fe=14.5f;
 fog_i(GL_FOG_MODE,GL_LINEAR);
 glFogfv(GL_FOG_COLOR,fc);
 glFogf(GL_FOG_DENSITY,fd);
 glFogf(GL_FOG_START,fs);
 glFogf(GL_FOG_END,fe);
 glEnable(GL_FOG);
 glEnable(GL_TEXTURE_2D);
  
  SDL_Event e;
  int quit=0;
  int info=0;// FOR CHECKING EVENTS.
  unsigned int framerate=(float)1000.0f/fps;float fpsm=0.0f;
  float screen_color[3]={1.0f,1.0f,1.0f},c1=1.0f,c2=1.0f,c3=1.0f,c4=1.0f;
  int m_foward=0,m_backward=0,m_left=0,m_right=0,m_up=0,m_down=0;
  float m_speed=3.25f,m_angle_h=0.0f,m_angle_v=0.0f;bool m_free_float=false;
  int c=0;
  //float xpos=0.0f,ypos=1.5f,zpos=-2.0f,xa=0.0f,ya=0.0f;
  
  
  
 load_textures();
 glEnableClientState(GL_VERTEX_ARRAY);
 glEnableClientState(GL_TEXTURE_COORD_ARRAY);
 glEnableClientState(GL_COLOR_ARRAY);
 
 
 set_walls(1);//cout<<number_of_walls<<endl;
 
 //cout<<"Number of collidable walls and floors on level 1 =   "<<cd_ref_now[0]<<endl;
 //cout<<"Number of collidable walls and floors on level 2 =   "<<cd_ref_now[1]<<endl;
 //cout<<"Number of collidable walls and floors on level 3 =   "<<cd_ref_now[2]<<endl;
 //cout<<"Number of collidable walls and floors on level 4 =   "<<cd_ref_now[3]<<endl;
 //cout<<"Number of collidable walls and floors on level 5 =   "<<cd_ref_now[4]<<endl;
 
 
 ms=0.1f;
 
/*for(int i=0;i<maxp*2;i++){
vertice[(i*9)+0]=0.0f;vertice[(i*9)+1]=0.0f;vertice[(i*9)+2]=0.0f;
vertice[(i*9)+3]=0.0f;vertice[(i*9)+4]=0.0f;vertice[(i*9)+5]=0.0f;
vertice[(i*9)+6]=0.0f;vertice[(i*9)+7]=0.0f;vertice[(i*9)+8]=0.0f;
texture_coordinate[(i*6)+0]=0.0f;texture_coordinate[(i*6)+1]=0.0f;
texture_coordinate[(i*6)+2]=0.0f;texture_coordinate[(i*6)+3]=0.0f;
texture_coordinate[(i*6)+4]=0.0f;texture_coordinate[(i*6)+5]=0.0f;
texture_select[(i*3)+0]=0;texture_select[(i*3)+1]=0;texture_select[(i*3)+2]=0;
colors[(i*12)+0]=1.0f;colors[(i*12)+1]=1.0f;colors[(i*12)+2]=1.0f;colors[(i*12)+3]=1.0f;
colors[(i*12)+4]=1.0f;colors[(i*12)+5]=1.0f;colors[(i*12)+6]=1.0f;colors[(i*12)+7]=1.0f;
colors[(i*12)+8]=1.0f;colors[(i*12)+9]=1.0f;colors[(i*12)+10]=1.0f;colors[(i*12)+11]=1.0f;}*/

pc=load_data();
  
  //  GAME LOOP STARTS HERE **************************************
while(quit==0){
info=check_for_event(e);if(info==2){quit=1;}
update_keyboard_state();

framerate=(float)1000.0f/fps;

/*
A SDLK_HOME
B SDLK_END
X SDLK_PAGEDOWN
Y SDLK_PAGEUP
START SDLK_LALT
SELECT SDLK_LCTRL
L SDLK_RSHIFT (?)
R SDLK_RCTRL (?)*/


 //       CONTROLS
 if(key[k_ESCAPE]){quit=1;}
 if(key[k_UP]){m_backward=1;}else{m_backward=0;}
 if(key[k_DOWN]){m_foward=1;}else{m_foward=0;}
 if(key[k_LEFT]){m_angle_h+=120.0f*ms;}
 if(key[k_RIGHT]){m_angle_h-=120.0f*ms;}
 if(key[k_RSHIFT]){m_left=1;}else{m_left=0;}
 if(key[k_RCTRL]){m_right=1;}else{m_right=0;}
 game_move(xpos,ypos,zpos,m_foward,m_backward,m_left,m_right,
           m_up,m_down,m_angle_h,m_angle_v,m_speed*ms,m_free_float);
   
/* if(key[SDLK_a]){change_tex_filter(tex_filter_none);}
 if(key[SDLK_z]){change_tex_filter(tex_filter_bilinear);}
*/
 

ypos-=1.8f*ms;if(ypos<0.0f){ypos=0.0f;}

//current_floor=0;
c=get_cd(cd_ref_now[current_floor]);
colission_detection_player(c);
//oxpos=xpos;oypos=ypos;ozpos=zpos;
/*
current_floor=1;
c=get_cd(number_of_walls);
colission_detection_player(c);

current_floor=2;
c=get_cd(number_of_walls);
colission_detection_player(c);

current_floor=3;
c=get_cd(number_of_walls);
colission_detection_player(c);

current_floor=4;
c=get_cd(number_of_walls);
colission_detection_player(c);*/
oxpos=xpos;oypos=ypos;ozpos=zpos;//cout<<ypos<<endl;


//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::: UPDATE FPS METER.
//fpsm=(float)1000.0f/(framerate-(currentTime-oldTime));
fpsm=(float)1000.0f/(ms*1000.0f);sprintf(temp,"%f",fpsm);
hmc0[4]=temp[0];hmc0[5]=temp[1];hmc0[6]=temp[2];hmc0[7]=temp[3];


 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 render(xpos,ypos+1.5f,zpos,m_angle_h,c1,c2,c3,c4);
 render_osd();
 swap_video_buffer


update_time(currentTime,oldTime);
if(currentTime-oldTime<framerate)
{delay_time((int)framerate-(currentTime-oldTime));}//ms=(float)(framerate-(currentTime-oldTime))/1000.0f;
update_time(currentTime,oldTime);
ms=(float)(currentTime-oldTime)/1000.0f;
update_time(oldTime,nullTime);}
free_textures();
glDisableClientState(GL_VERTEX_ARRAY);
glDisableClientState(GL_TEXTURE_COORD_ARRAY);
glDisableClientState(GL_COLOR_ARRAY);
#ifdef PANDORA
EGL_Destroy();
#endif
SDL_Quit();
return 0;
}
